import React from "react";
import getWeb3 from "./getWeb3";

export class Web3Container extends React.Component {
  constructor(props) {
    super(props);
    this.state = { web3: null, accounts: null, contract: null };
  }

  async componentDidMount() {
    try {
      const web3 = await getWeb3();
      const accounts = this.fetchAccounts();
      this.setState({ web3, accounts });
    } catch (error) {
      alert(`Failed to load web3, accounts. Check console for details.`);
    }
  }

  async fetchAccounts() {
    const web3 = await getWeb3();
    const accounts = await web3.eth.getAccounts();

    if (accounts.length === 0) {
      web3
        && web3.currentProvider
        && web3.currentProvider
          .enable()
          .then(accounts => this.setState({
            accounts
          })
          )
          .catch((err) => {
            this.setState({
              accountsError: err
            });
          });
    } else {
      return accounts;
    }
  }

  render() {
    const { web3, accounts } = this.state;
    return web3 && accounts.length > 0
      ? this.props.render({ web3, accounts })
      : this.props.renderLoading();
  }
}
